//+------------------------------------------------------------------+
//|                                        pivot detector oscillator |
//|                                                                  |
//| developed by Giorgos Siligardos,                                 |
//| published in TASC, September, 2009                               |
//+------------------------------------------------------------------+
#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    1
#property indicator_color1     DeepSkyBlue
#property indicator_width1     2
#property indicator_level1     0
#property indicator_level2     100
#property indicator_levelcolor DimGray


//
//
//
//
//

extern int timeFrame         = 0;
extern int pdoPrice          = PRICE_CLOSE;
extern int pdoRsiLength      = 14;
extern int pdoAverageLength  = 200;
extern int pdoUpTrendEntry   = 35;
extern int pdoUpTrendExit    = 85;
extern int pdoDownTrendEntry = 20;
extern int pdoDownTrendExit  = 70;

double pdo[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,pdo);
      timeFrame= MathMax(timeFrame,Period());
   IndicatorShortName("pdo ("+pdoRsiLength+","+pdoAverageLength+","+pdoUpTrendEntry+","+pdoUpTrendExit+","+pdoDownTrendEntry+","+pdoDownTrendExit+")");
   return(0);
}
int deinit() { return(0); }
int start()
{
   int i,limit;
   int counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
            limit=MathMax(Bars-counted_bars,MathMin(Bars-1,3*timeFrame/Period()));
 
   //
   //
   //
   //
   //
 
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double rsi   = iRSI(NULL,timeFrame,pdoRsiLength,pdoPrice,y);
      double avg   = iMA(NULL,timeFrame,pdoAverageLength,0,MODE_SMA,pdoPrice,y);
      double price = iMA(NULL,0,1                       ,0,MODE_SMA,pdoPrice,y);
      
      if (price>avg)
            pdo[i] = 100*(rsi-pdoUpTrendEntry)/(pdoUpTrendExit-pdoUpTrendEntry);
      else  pdo[i] = 100*(rsi-pdoDownTrendEntry)/(pdoDownTrendExit-pdoDownTrendEntry);
   }                  
   return(0);
}